#include <qtest.h>
#include <QtQml/qqmlengine.h>
#include <private/qquicktextedit_p.h>
#include <QtTest/QSignalSpy>

class cursorRectTest : public QObject
{
    Q_OBJECT

private slots:
    void cursorRectChanged();
};


void cursorRectTest::cursorRectChanged()
{
    QQmlEngine engine;
    QQmlComponent texteditComponent(&engine);
    texteditComponent.setData("import QtQuick 2.0\nTextEdit { wrapMode: TextEdit.WordWrap; text: \"foo\" }", QUrl());
    QQuickTextEdit *edit = qobject_cast<QQuickTextEdit*>(texteditComponent.create());

    QSignalSpy editSpy(edit, SIGNAL(cursorRectangleChanged()));

    // Verify that the micro focus rect is positioned the same for position 0 as
    // it would be if there was no preedit text.
    QString preeditText = "super";
    QInputMethodEvent imEvent(preeditText, QList<QInputMethodEvent::Attribute>()
                              << QInputMethodEvent::Attribute(QInputMethodEvent::Cursor, 0, preeditText.length(),
                                                              QVariant()));
    QCoreApplication::sendEvent(edit, &imEvent);
    QCOMPARE(editSpy.count(), 0);

    edit->setCursorPosition(0);
    editSpy.clear();
    edit->insert(2, "bar");
    QCOMPARE(editSpy.count(), 0);    
}

QTEST_MAIN(cursorRectTest)

#include "cursorrect.moc"
